#!/usr/bin/perl
# author: Fuyuncat
# Site:   WWW.HelloDBA.COM
# Script: http://www.Hellodba.com/Download/Appr_NDV.zip
# Purpose: to simulate the bloom filter.

#use strict;
#use warnings;
use POSIX;

sub round {
    my($number) = shift;
    return int($number + .5);
}

sub hash_func {
    my $x = ((($_[0]<<$_[1])^($_[0]>>ceil($_[1]/2)))%$_[2]);
    return $x;
}

sub dec_to_bin {
	my $dec = $_[0];
	$bin=unpack("B32",pack("N",$dec));
	return substr($bin,32-$bitsize,$bitsize);
}

sub print_arr {
	my $arr = $_[0];
	print "( ";
	for (my $i=0;$i<@synopsis.count+0;$i++) {
		print dec_to_bin($synopsis[$i])." ";
	}
	print ") \n";
}

sub splitset {
	print " splitting (current level: ".$level.") ";
print_arr()." \n";
	$discarded = 0;
#	print " old size: ".(@synopsis.count+0)." \n ";
	while ($discarded == 0 && $level < $bitsize) {
		@temparr = ();
		$s = 0;
		$level = $level+1;
		$checknum = $checknum+2**($bitsize-$level);
		for (my $i=0;$i<@synopsis.count+0;$i++) {
			if (tobediscarded($synopsis[$i]) == 1) {
				$discarded++;
			} else {
				$temparr[$s] = $synopsis[$i];
				$s++;
			}
		}
#	print "checking num: ".dec_to_bin(getchknum())." ";
#	print " temp size: ".(@temparr.count+0)." \n ";
		@synopsis = @temparr;
	}
#	print " new size: ".(@synopsis.count+0)." \n ";
}

sub insertset {
	my $newdata = $_[0];
	if (checkset($newdata) == 1) {
		if (@synopsis.count+0 >= $setsize) {
			splitset();
		}
		if (tobediscarded($newdata) == 0) {
			$synopsis[@synopsis.count+0] = $newdata;
			return 1;
		}
	}
	return 0;
}

sub getchknum {
	my $checknum = 0;
    for (my $i=0;$i<$level;$i++) {
		$checknum = $checknum+2**($bitsize-1-$i);
	}
	return $checknum;
}

sub tobediscarded {
	my $newdata = $_[0];
#	my $checknum = getchknum();
	if (($newdata & $checknum) > 0){
		return 1;
	} else {
		return 0;
	}
}

sub checkset {
	my $newdata = $_[0];
    for (my $i=0;$i<@synopsis.count+0;$i++) {
        if ($newdata == $synopsis[$i]) {
			return 0;
		}
    }
	return 1;
}

sub checkdup {
	my $newdata = $_[0];
	my $end = $_[1];
    for (my $i=0;$i<$end;$i++) {
        if ($newdata == $array[$i]) {
			return 0;
		}
    }
	return 1;
}

our $bitsize = $ARGV[0];
our $setsize = $ARGV[1];
our $datanum = $ARGV[2];

our $level = 0;
our $checknum = 0;

    # initialize a random array
    @array=();
	@synopsis=();
    for (my $i=0;$i<$datanum;$i++) {
#      $array[$i]=$array[$i-1]+1+floor(rand(100));
      $array[$i]=floor(rand(100));
#      print ",".$array[$i];
    }
#    print "\n";
    for (my $i=0;$i<$datanum;$i++) {
		my $hs = hash_func($array[$i],10,(2**$bitsize));
		print $i." Scaning ".$array[$i]." (Hash: ".dec_to_bin($hs).") ";
		if (insertset($hs) == 1) {
			print "inserted. ";
		} else {
			print "discarded. ";
		}
#		print_arr();
 		print " \n";
   }
	$apprndv = (@synopsis.count+0) * (2**$level);

    #get the actual NDV
    $actualndv = 0;
    for (my $i=0;$i<$datanum;$i++) {
        if (checkdup($array[$i],$i) == 1) {
            $actualndv++;
		}
    }


print "Approximated NDV:".$apprndv."( element num: ".(@synopsis.count+0).", level: ".$level."); Actual NDV:".$actualndv."\n"
